<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">
<head>
  <title>debconf5 | See you in hel</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
<style type="text/css" media="all">@import "http://www.debconf.org/debconf5/misc/drupal.css";</style>
<style type="text/css">@import url(http://www.debconf.org/debconf5/modules/event/event.css);</style>
<link rel="alternate" type="application/rss+xml" title="RSS" href="http://www.debconf.org/debconf5/node/feed" />

  <style type="text/css" media="all">@import "http://www.debconf.org/debconf5/themes/debconf5/style.css";</style>

  <script type="text/javascript"> </script>
</head>

<body bgcolor="#ffffff" >

<div class="hide"><a href="http://www.debconf.org/debconf5/#content" title="Skip navigation." accesskey="2">Skip navigation</a>.</div>
      <!--a href="http://www.debconf.org/debconf5/" title="Home"><img src="http://www.debconf.org/debconf5/files/logo.png" alt="Home" width="144" height="63" border="0" /></a-->
      <!--div class='site-name'><a href="http://www.debconf.org/debconf5/./" title="Home">debconf5</a></div-->
<table id="top_line" border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>

    <td width="15"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_left_15.png"></td>
    <td class="middle" width="100%"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png"></td>
    <td width="15"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_right_15.png"></td>
  </tr>
</table>
<table id="content" border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>	
	<td colspan="5">
		<table id="primary-menu" summary="Navigation elements." border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tr>

		    <td width="5"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_left.png"></td>
		    <td class="top_left"><a href="http://www.debconf.org/debconf5/"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_img.jpg"></a></td>
		    <td class="top_right" width="219" valign="top">
			   <table>
				<tr>
				  <td colspan="6"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" height="10"></td>
				</tr>
				<tr>
				  <td><a href="http://www.debconf.org/debconf5/"><img src="http://www.debconf.org/debconf5/themes/debconf5/home.jpg"></a></td>

				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/nav_divider.jpg"></td>
				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" width="10" height="29"></td>
				  <td><a href="http://www.debconf.org/debconf5/search"><img src="http://www.debconf.org/debconf5/themes/debconf5/search.jpg"></a></td>
				  <td><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" width="10"></td>
				</tr>
				<tr>
				  <td colspan="6"><form action="http://comas.linux-aktivaattori.org/comas/general/proposals/search" method="post">
    				    <div id="search">

  		  	 	  	<input class="form-text" type="text" size="15" value="" name="keys" alt="Enter the terms you wish to search for." />
    				      	<input class="form-submit" type="submit" value="Search" alt="submit" />
				        </div>
				      </form></td>	
				</tr>
			   </table>
			</td>
		    <td width="5"><img src="http://www.debconf.org/debconf5/themes/debconf5/top_right.png"></td>
		  </tr>

		</table>
		<table id="bottom_line" border="0" cellpadding="0" cellspacing="0" width="100%">
		  <tr>
		    <td class="middle" width="100%"><img src="http://www.debconf.org/debconf5/themes/debconf5/transparent.png" height="7"></td>
		  </tr>
		</table>	
	</td>
  </tr>
  <tr>
  	<td colspan="5">
<div id="container">
<br/>
	<div id="comas" style="margin-left: 4%">


<h1>Multiarch - An a proposal and an implementation</h1>

<h2>Proposal details:</h2>

<table class="comas-table" width=100%>

<tr>
<td class="name">Abstract:</td>
<td class="input"><p><div class="hft-lines">Since the debian-amd64 port started, there has been rumors and<br />
half-way implementations of a hybrid system which supports both i386<br />
and amd64 packages.  This was first known as biarch then multiarch.  <br />
<br />
Multiarch is an implementation of a Debian system which exploits the<br />
possibilities inherent to architectures (used in the Debian sense)<br />
such as amd64, sparc and Nienna, better known as &quot;Debian NetBSD&quot;.  It<br />
allows the system to have .debs for multiple architectures installed<br />
in a sensible way (meaning not separate chroots, for instance) and a<br />
way to express trans-architectural dependencies.<br />
<br />
The multiarch proposals have been floating around for a long time now<br />
and they were discussed fairly heavily at the last Debconf.  As part<br />
of my master's thesis, I am doing an implementation of a<br />
partly-multiarched system.  It shows that it is both possible to do a<br />
multiarched system as well as outlining some of the issues that will<br />
crop up.<br />
<br />
As such, the proposal has two parts.  One is mostly-agreed on, the<br />
other is more contested.  The parts are the file system implementation<br />
and how to implement this in dpkg and Debian packages.<br />
<br />
The file system implementation only speaks of libraries and library<br />
packages as those are the most interesting to make multiarch capable.<br />
Other packages which might be multiarched is the toolchain, since it<br />
has good support for coinstallations already, but having multiple<br />
installations of coreutils or sed does not really make any sort of<br />
sense.<br />
<br />
For libraries, they will install their files in /lib/$(gcc<br />
-dumpmachine) or /usr/lib/$(gcc -dumpmachine) as appropriate.  gcc<br />
-dumpmachine outputs a string similar to i486-linux, x86_64-linux.<br />
<br />
For programs wanting to be multiarched, applying a transformation<br />
similar to what gcc use would probably be the right way.  (gcc becomes<br />
x86_64-linux-gcc and so on.)<br />
<br />
On the packaging side of things, there are currently two proposals.<br />
One by Tollef Fog Heen (with input from different people on Debian<br />
mailing lists) and one by Anthony Towns.<br />
<br />
Both proposals means splitting packages is necessary, as files common<br />
to multiple architectures would cause overlap (think /usr/share).<br />
The proposal which is implemented here is Tollef's.  It implies<br />
extending the semantics of a Depends field from what it is today where<br />
<br />
| Package: fruits<br />
| Depends: banana<br />
| Architecture: i386<br />
<br />
means &quot;needs a banana package installed&quot; to &quot;needs an i386 banana<br />
installed&quot;.  <br />
<br />
| Package: fruits<br />
| Depends: banana:any<br />
| Architecture: i386<br />
<br />
on the other hand means &quot;I just need a banana package installed, I<br />
do not care about the architecture&quot;.<br />
<br />
The talk will concentrate around the issues which pops up when such<br />
changes are made, the needed change to infrastructure and core<br />
utilities such as dpkg.<br />
<br />
About the author:<br />
<br />
Tollef Fog Heen is a Debian Developer and has been since early 2001.<br />
He has been involved in a lot of different Debian projects from<br />
rejuvenating the debian-installer project to general package<br />
maintainance and porting work on the AMD64 port.  He has been working on<br />
multiarch since early 2004.<br /></div></p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Presentation type:</td>
<td class="input"><p>Talk (45 min)</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Track:</td>
<td class="input"><p>Technical</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

<tr>
<td class="name">Status:</td>
<td class="input"><p>Accepted</p></td>
<td class="error"><p>&nbsp;</p></td>
</tr>

</table>

<h2>Authors:</h2>

<ul>

<li><p>Tollef Fog Heen</p>


</li>

</ul>

<h2>Files:</h2>

<ul>

</ul>

<center>
<input type="button" value="Go back" onClick="history.go(-1)">
</center>

	</div>
<br/>
<hr/>
</div>
<div id="bottom" class="margin-left: 4%">
&nbsp;<a href="http://www.debconf.org/debconf5">Debconf 5</a><br/> 
&nbsp;&nbsp;&nbsp;Powered by <a href="http://gborg.postgresql.org/project/comas">COMAS</a>, 
the Conference Management System by <a href="http://www.consol.org.mx">CONSOL</a>
</div>
</td>
</tr>
</table>

</body>
</html>

